/**********************************************************************
 * Ngaro VM
 * Copyright (C) 2008 - 2011, Charles Childers
 **********************************************************************/


/**********************************************************************
 * Mouse / Touch Support
 **********************************************************************/
var mx, my, mb;

function moveMouse(e)
{
  if (e.offsetX)
  {
    mx = e.offsetX;
    my = e.offsetY;
  }
  else if (e.layerX)
  {
    mx = e.layerX;
    my = e.layerY;
  }
  return true;
}

function setButton(e)
{
  mb = 1;
  return true;
}

function releaseButton(e)
{
  mb = 0;
  return true;
}

document.onmousedown = setButton;
document.onmouseup = releaseButton;
document.onmousemove = moveMouse;

portHandlers[7] = function()
{
  if (ports[7] == 1)
  {
    data.push(mx);
    data.push(my);
    ports[7] = 0;
  }
  if (ports[7] == 2)
  {
    data.push(mb);
    ports[7] = 0;
  }
}


/**********************************************************************
 * Canvas Support
 **********************************************************************/
var fb, fbraw;

function rxClearCanvas()
{
  fb.clearRect(0, 0, FB_WIDTH, FB_HEIGHT);
}

function toggleCanvas()
{
  var div = document.getElementById('framebuffer');
  if (div.style.display == 'block') {
      div.style.display = 'none';
  }
  else {
      div.style.display = 'block';
  }
}

function init_fb()
{
  fbraw = document.getElementById("framebuffer");
  fb = fbraw.getContext("2d");
}

function video_color(c)
{
  if (c == 0)
    fb.fillStyle = "black";
  if (c == 1)
    fb.fillStyle = "darkblue";
  if (c == 2)
    fb.fillStyle = "darkgreen";
  if (c == 3)
    fb.fillStyle = "darkcyan";
  if (c == 4)
    fb.fillStyle = "darkred";
  if (c == 5)
    fb.fillStyle = "purple";
  if (c == 6)
    fb.fillStyle = "brown";
  if (c == 7)
    fb.fillStyle = "darkgray";
  if (c == 8)
    fb.fillStyle = "gray";
  if (c == 9)
    fb.fillStyle = "blue";
  if (c == 10)
    fb.fillStyle = "green";
  if (c == 11)
    fb.fillStyle = "cyan";
  if (c == 12)
    fb.fillStyle = "red";
  if (c == 13)
    fb.fillStyle = "magenta";
  if (c == 14)
    fb.fillStyle = "yellow";
  if (c == 15)
    fb.fillStyle = "white";
  if (c < 0 || c > 15)
    fb.fillStyle = "black";
}

function video_pixel(x, y)
{
  fb.fillRect(x, y, 2, 2);
}

function video_rect(x, y, w, h)
{
  fb.strokeRect(x, y, w, h);
}

function video_fillRect(x, y, w, h)
{
  fb.fillRect(x, y, w, h);
}

function video_hline(x, y, w)
{
  fb.fillRect(x, y, w, 2);
}

function video_vline(x, y, h)
{
  fb.fillRect(x, y, 2, h);
}

function video_circle(x, y, w)
{
  fb.beginPath();
  fb.arc(x, y, w, 0, Math.PI*2, true);
  fb.closePath();
  fb.stroke();
}

function video_fillCircle(x, y, w)
{
  fb.beginPath();
  fb.arc(x, y, w, 0, Math.PI*2, true);
  fb.closePath();
  fb.fill();
}


portHandlers[6] = function()
{
  if (ports[6] == 1)
  {
    video_color(data.pop());
    ports[6] = 0;
  }
  if (ports[6] == 2)
  {
    var x, y;
    y = data.pop();
    x = data.pop();
    video_pixel(x, y);
    ports[6] = 0;
  }
  if (ports[6] == 3)
  {
    var x, y, h, w;
    w = data.pop();
    h = data.pop();
    y = data.pop();
    x = data.pop();
    video_rect(x, y, w, h);
    ports[6] = 0;
  }
  if (ports[6] == 4)
  {
    var x, y, h, w;
    w = data.pop();
    h = data.pop();
    y = data.pop();
    x = data.pop();
    video_fillRect(x, y, w, h);
    ports[6] = 0;
  }
  if (ports[6] == 5)
  {
    var x, y, h;
    h = data.pop();
    y = data.pop();
    x = data.pop();
    video_vline(x, y, h);
    ports[6] = 0;
  }
  if (ports[6] == 6)
  {
    var x, y, w;
    w = data.pop();
    y = data.pop();
    x = data.pop();
    video_hline(x, y, w);
    ports[6] = 0;
  }
  if (ports[6] == 7)
  {
    var x, y, w;
    w = data.pop();
    y = data.pop();
    x = data.pop();
    video_circle(x, y, w);
    ports[6] = 0;
  }
  if (ports[6] == 8)
  {
    var x, y, w;
    w = data.pop();
    y = data.pop();
    x = data.pop();
    video_fillCircle(x, y, w);
    ports[6] = 0;
  }
}

